--- linux-linaro-3.4-2012.05-1_original/include/linux/spi/cnc18xx_spi.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/include/linux/spi/cnc18xx_spi.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,19 @@
+/*
+ * orion_spi.h
+ *
+ * This file is licensed under the terms of the GNU General Public
+ * License version 2. This program is licensed "as is" without any
+ * warranty of any kind, whether express or implied.
+ */
+
+#ifndef __LINUX_SPI_CNC18XX_SPI_H
+#define __LINUX_SPI_CNC18XX_SPI_H
+
+struct cnc18xx_spi_info {
+	u32	tclk;		/* no <linux/clk.h> support yet */
+	u32	enable_clock_fix;
+	u32 max_rcv_sz;
+};
+
+
+#endif
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/include/linux/sw_ipi.h linux-linaro-3.4-2012.05-1_cavium/include/linux/sw_ipi.h
--- linux-linaro-3.4-2012.05-1_original/include/linux/sw_ipi.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/include/linux/sw_ipi.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,24 @@
+#ifndef __SW_IPI_H_
+#define __SW_IPI_H_
+#include <linux/workqueue.h>
+#include <linux/interrupt.h>
+
+u32 sw_send_smc(u32 cmd, u32 arg1, u32 arg2, u32 arg3);
+
+int sw_register_ipi_handler(int ipi_num, int irq_num, void* func, void *data);
+
+void sw_unregister_ipi_handler(int ipi_num);
+
+void vm_interrupt_wrapper(struct work_struct *new_work);
+
+int hyp_notify_handler(unsigned int irq, void (*handler)(struct work_struct *),
+		unsigned long irqflags, const char *devname, void *dev_id);
+
+struct sw_ipi_info{
+	struct work_struct work;
+	int irq_num;	
+	char* pri_data;
+};
+
+#endif
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/include/linux/usb/ch11.h linux-linaro-3.4-2012.05-1_cavium/include/linux/usb/ch11.h
--- linux-linaro-3.4-2012.05-1_original/include/linux/usb/ch11.h	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/include/linux/usb/ch11.h	2014-07-29 17:28:38.819972000 +0800
@@ -33,6 +33,7 @@
  */
 #define HUB_SET_DEPTH		12
 #define HUB_GET_PORT_ERR_COUNT	13
+#define HUB_SET_AND_TEST        14
 
 /*
  * Hub Class feature numbers
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/include/linux/usb/gadget.h linux-linaro-3.4-2012.05-1_cavium/include/linux/usb/gadget.h
--- linux-linaro-3.4-2012.05-1_original/include/linux/usb/gadget.h	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/include/linux/usb/gadget.h	2014-07-29 17:28:38.819972000 +0800
@@ -26,6 +26,39 @@
 
 struct usb_ep;
 
+#ifdef DWC_UTE_PER_IO
+
+struct dwc_ute_iso_packet_descriptor {
+        uint32_t offset;
+        uint32_t length;                /* expected length */
+        uint32_t actual_length;
+        uint32_t status;
+};
+
+struct dwc_ute_iso_req_ext {
+        /** transfer/submission flag */
+        uint32_t tr_sub_flags;
+/** Start the request ASAP */
+#define DWC_UTE_TF_ASAP         0x00000002
+/** Just enqueue the request w/o initiating a transfer */
+#define DWC_UTE_TF_ENQUEUE      0x00000004
+
+        /** 
+ *  *          * Count of ISO packet descriptors attached to this request - shall 
+ *   *                   * not exceed the pio_alloc_pkt_count 
+ *    *                            */
+        uint32_t pio_pkt_count;
+        /** count of ISO packet descriptors allocated for this request */
+        uint32_t pio_alloc_pkt_count;
+        /** number of ISO packet errors */
+        uint32_t error_count;
+        /** reserved for future extension */
+        uint32_t res;
+        /** Will be allocated and freed in the UTE gadget and based on the CFC value */
+        struct dwc_ute_iso_packet_descriptor *per_io_frame_descs;
+};
+#endif
+
 /**
  * struct usb_request - describes one i/o request
  * @buf: Buffer used for data.  Always provide this; some controllers
@@ -108,6 +141,12 @@
 
 	int			status;
 	unsigned		actual;
+
+/* The SNPS UTE specific extension for the periodic transfers */
+#ifdef DWC_UTE_PER_IO
+        struct dwc_ute_iso_req_ext ext_req;
+#endif
+
 };
 
 /*-------------------------------------------------------------------------*/
@@ -466,6 +505,7 @@
 	int	(*pullup) (struct usb_gadget *, int is_on);
 	int	(*ioctl)(struct usb_gadget *,
 				unsigned code, unsigned long param);
+        int     (*lpm_support) (struct usb_gadget *);
 	void	(*get_config_params)(struct usb_dcd_config_params *);
 	int	(*udc_start)(struct usb_gadget *,
 			struct usb_gadget_driver *);
@@ -764,6 +804,19 @@
 	return gadget->ops->pullup(gadget, 0);
 }
 
+/**
+ * usb_gadget_test_lpm_support - Is LPM (Linked Power Menegment) supported.
+ * @gadget:the device to check for LPM support
+ *
+ * Returns 1 if LPM is supported 0 otherwise
+ */
+static inline int
+usb_gadget_test_lpm_support (struct usb_gadget *gadget)
+{
+	if (!gadget->ops->lpm_support)
+		return -EOPNOTSUPP;
+	return gadget->ops->lpm_support (gadget);
+}
 
 /*-------------------------------------------------------------------------*/
 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/include/linux/usb/g_hid.h linux-linaro-3.4-2012.05-1_cavium/include/linux/usb/g_hid.h
--- linux-linaro-3.4-2012.05-1_original/include/linux/usb/g_hid.h	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/include/linux/usb/g_hid.h	2014-07-29 17:28:38.819972000 +0800
@@ -21,12 +21,28 @@
 #ifndef __LINUX_USB_G_HID_H
 #define __LINUX_USB_G_HID_H
 
+#define CONFIG_NOT_DONE                 (0)
+#define CONFIG_DONE                     (1)
+
+#define HIDG_MAX_REPORT_DESC_SIZE         (1024)      /* TODO: Verify this size would be sufficeint for all type of Gadget devices */
+
 struct hidg_func_descriptor {
 	unsigned char		subclass;
 	unsigned char		protocol;
+    unsigned char       feature_report[10][257];
+    unsigned short      feature_report_length[10];
 	unsigned short		report_length;
 	unsigned short		report_desc_length;
-	unsigned char		report_desc[];
+	unsigned char		report_desc[HIDG_MAX_REPORT_DESC_SIZE];
 };
 
+/* ioctl interface */
+
+/* The 'g' code is also used by gadgetfs ioctl requests.
+ * Don't add any colliding codes to either driver, and keep
+ * them in unique ranges (size 0x20 for now).
+ */
+
+#define GET_GADGET_HID_DEVICE_CONFIG_STATUS    _IOR('g', 0x41, unsigned char)
+
 #endif /* __LINUX_USB_G_HID_H */
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/include/linux/usb/hcd.h linux-linaro-3.4-2012.05-1_cavium/include/linux/usb/hcd.h
--- linux-linaro-3.4-2012.05-1_original/include/linux/usb/hcd.h	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/include/linux/usb/hcd.h	2014-07-29 17:28:38.819972000 +0800
@@ -501,6 +501,7 @@
 #define GetPortStatus		(0xa300 | USB_REQ_GET_STATUS)
 #define SetHubFeature		(0x2000 | USB_REQ_SET_FEATURE)
 #define SetPortFeature		(0x2300 | USB_REQ_SET_FEATURE)
+#define SetandTestPortFeature   (0xa300 | HUB_SET_AND_TEST)
 
 
 /*-------------------------------------------------------------------------*/
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/include/linux/usb.h linux-linaro-3.4-2012.05-1_cavium/include/linux/usb.h
--- linux-linaro-3.4-2012.05-1_original/include/linux/usb.h	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/include/linux/usb.h	2014-07-29 17:28:38.819972000 +0800
@@ -329,6 +329,9 @@
 					 * for control transfers?
 					 */
 	u8 otg_port;			/* 0, or number of OTG/HNP port */
+#ifdef CONFIG_USB_OTG
+	u16 otg_version;		/* OTG version supported by HCD - SNPS*/	
+#endif
 	unsigned is_b_host:1;		/* true during some HNP roleswitches */
 	unsigned b_hnp_enable:1;	/* OTG: did A-Host enable HNP? */
 	unsigned sg_tablesize;		/* 0 or largest number of sg list entries */
@@ -516,6 +519,9 @@
 #endif
 	struct wusb_dev *wusb_dev;
 	int slot_id;
+#ifdef CONFIG_USB_SNPS_DWC_OTG2
+        struct delayed_work hnp_poll_work;  /* Drives HNP polling */
+#endif
 	enum usb_device_removable removable;
 };
 #define	to_usb_device(d) container_of(d, struct usb_device, dev)
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/init/initramfs.c linux-linaro-3.4-2012.05-1_cavium/init/initramfs.c
--- linux-linaro-3.4-2012.05-1_original/init/initramfs.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/init/initramfs.c	2014-07-29 17:28:38.819972000 +0800
@@ -579,7 +579,7 @@
 }
 EXPORT_SYMBOL(populate_rootfs_wait);
 
-static void __init async_populate_rootfs(void)
+static void __init async_populate_rootfs(void *data, async_cookie_t cookie)
 {
 	char *err = unpack_to_rootfs(__initramfs_start, __initramfs_size);
 	if (err)
@@ -628,12 +628,14 @@
 		async_schedule_domain(async_populate_rootfs, NULL,
 						&populate_rootfs_domain);
 	}
+	return 0;
 }
 static int __init populate_rootfs(void)
 {
 	if (!rootfs_populated)
 		async_schedule_domain(async_populate_rootfs, NULL,
 						&populate_rootfs_domain);
+	return 0;
 }
 
 earlyrootfs_initcall(populate_rootfs_early);
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/init/main.c linux-linaro-3.4-2012.05-1_cavium/init/main.c
--- linux-linaro-3.4-2012.05-1_original/init/main.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/init/main.c	2014-07-29 17:28:38.819972000 +0800
@@ -90,7 +90,9 @@
 #ifndef CONFIG_DEBUG_RODATA
 static inline void mark_rodata_ro(void) { }
 #endif
-
+#ifdef CONFIG_SW_SUPPORT
+extern void sw_ipi_handler_init(void);
+#endif
 #ifdef CONFIG_TC
 extern void tc_init(void);
 #endif
@@ -231,7 +233,7 @@
 early_param("loglevel", loglevel);
 
 /* Change NUL term back to "=", to make "param" the whole string. */
-static int __init repair_env_string(char *param, char *val)
+static int __init repair_env_string(char *param, char *val, int known)
 {
 	if (val) {
 		/* param=val or param="val"? */
@@ -254,7 +256,7 @@
  */
 static int __init pass_bootoption(char *param, char *val, int all)
 {
-	repair_env_string(param, val);
+	repair_env_string(param, val, all);
 
 	/* Handle obsolete-style parameters */
 	if (obsolete_checksetup(param) && !all)
@@ -621,6 +623,9 @@
 		late_time_init();
 	sched_clock_init();
 	calibrate_delay();
+#ifdef CONFIG_SW_SUPPORT
+	sw_ipi_handler_init();
+#endif
 	pidmap_init();
 	anon_vma_init();
 #ifdef CONFIG_X86
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/kernel/power/main.c linux-linaro-3.4-2012.05-1_cavium/kernel/power/main.c
--- linux-linaro-3.4-2012.05-1_original/kernel/power/main.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/kernel/power/main.c	2014-07-29 17:28:38.819972000 +0800
@@ -20,6 +20,16 @@
 
 DEFINE_MUTEX(pm_mutex);
 
+#ifdef CONFIG_ARCH_CELESTIAL
+uint32_t irq_list_length = 0;
+uint32_t gpio_wakeup_list = 0xffffffff;
+uint32_t irq_mask_list[MAX_MASKABLE_IRQS];
+uint32_t irq_mask_temp[MAX_MASKABLE_IRQS];
+EXPORT_SYMBOL(irq_list_length);
+EXPORT_SYMBOL(irq_mask_list);
+EXPORT_SYMBOL(gpio_wakeup_list);
+#endif
+
 #ifdef CONFIG_PM_SLEEP
 
 /* Routines for PM-transition notifications */
@@ -405,6 +415,150 @@
 power_attr(wake_unlock);
 #endif
 
+#ifdef CONFIG_ARCH_CELESTIAL
+static ssize_t irqs_to_mask_show(struct kobject *kobj, struct kobj_attribute *attr, char *buf)
+{
+    ssize_t rv = 0, cnt = 0;
+    uint32_t ix = 0;
+    char *bp = buf;
+
+    if (irq_list_length == 0) {
+        *bp++ = '\n';
+        *bp = '\0';
+        return 1;
+    }
+    cnt = sprintf(bp, "%u", irq_mask_list[0]);
+    bp += cnt;
+    rv += cnt;
+    for (ix = 1; ix < irq_list_length; ++ix) {
+        cnt = sprintf(bp, " %u", irq_mask_list[ix]);
+        bp += cnt;
+        rv += cnt;
+    }
+    *bp++ = '\n';
+    ++rv;
+    *bp = '\0';
+    return rv;
+}
+
+static ssize_t gpio_wakeup_show(struct kobject *kobj, struct kobj_attribute *attr, char *buf)
+{
+    uint32_t v = gpio_wakeup_list;
+    char *p = buf;
+    int cnt = 0, first_bit = 1; unsigned bitno = 0;
+
+    for (bitno = 0; bitno < 32; ++bitno) {
+        if ((v & 1) == 0) {
+            if (!first_bit) {
+                *p++ = ' ';
+            } else {
+                first_bit = 0;
+            }
+            cnt = sprintf(p, "%u", bitno);
+            p += cnt;
+        }
+        v >>= 1;
+    }
+    *p++ = '\n';
+    *p = '\0';
+    return (ssize_t)(p - buf);
+}
+
+static ssize_t irqs_to_mask_store(struct kobject *kobj,
+                                  struct kobj_attribute *attr,
+                                  const char *buf, size_t sz)
+{
+    const char *ptr = buf;
+    uint32_t irqno = 0, ix = 0;
+
+    if (*ptr == '\n' || *ptr == '\0') {
+        return sz;
+    }
+
+    /* We keep a temporary array to store parsed IRQ #s, so that if the
+       string turns out to be invalid, we can discard the list and still keep
+       the existing one. */
+    while (1 == 1) {
+        /* Decimal #s only right now. */
+        while (*ptr >= '0' && *ptr <= '9') {
+            irqno = irqno*10 + (*ptr - '0');
+            if (irqno >= MAX_MASKABLE_IRQS) {
+                return -EINVAL; /* Disallow overflow or too large irq # */
+            }
+            ++ptr;
+        }
+        if (!(*ptr == ' ' || *ptr == '\t' || *ptr == '\n' || *ptr == '\0')) {
+            return -EINVAL;
+        }
+        irq_mask_temp[ix++] = irqno;
+        irqno = 0;
+        if (*ptr == '\n' || *ptr == '\0') {
+            break;
+        }
+        do {
+            ++ptr;
+        } while (*ptr == ' ' || *ptr == '\t');
+        if (*ptr == '\n' || *ptr == '\0') {
+            break;
+        }
+    }
+
+    irq_list_length = ix;
+    for (ix = 0; ix < irq_list_length; ++ix) {
+        irq_mask_list[ix] = irq_mask_temp[ix];
+    }
+
+    return (ssize_t)sz;
+}
+
+static ssize_t gpio_wakeup_store(struct kobject *kobj,
+                                  struct kobj_attribute *attr,
+                                  const char *buf, size_t sz)
+{
+    const char *ptr = buf;
+    uint32_t pin_num = 0;
+    uint32_t temp = (uint32_t)(-1);
+
+    if (*ptr == '\n' || *ptr == '\0') {
+        return sz;
+    }
+
+    /* We keep a temporary array to store parsed pin #s, so that if the
+       string turns out to be invalid, we can discard the list and still keep
+       the existing one. */
+    while (1 == 1) {
+        /* Decimal #s only right now. */
+        while (*ptr >= '0' && *ptr <= '9') {
+            pin_num = pin_num*10 + (*ptr - '0');
+            if (pin_num >= 32) {
+                return -EINVAL; /* Disallow overflow or too large pin # */
+            }
+            ++ptr;
+        }
+        if (!(*ptr == ' ' || *ptr == '\t' || *ptr == '\n' || *ptr == '\0')) {
+            return -EINVAL;
+        }
+        temp &= ~(1 << pin_num);
+        pin_num = 0;
+        if (*ptr == '\n' || *ptr == '\0') {
+            break;
+        }
+        do {
+            ++ptr;
+        } while (*ptr == ' ' || *ptr == '\t');
+        if (*ptr == '\n' || *ptr == '\0') {
+            break;
+        }
+    }
+
+    gpio_wakeup_list = temp;
+    return (ssize_t)sz;
+}
+
+power_attr(irqs_to_mask);
+power_attr(gpio_wakeup);
+#endif
+
 static struct attribute * g[] = {
 	&state_attr.attr,
 #ifdef CONFIG_PM_TRACE
@@ -422,6 +576,10 @@
 	&wake_unlock_attr.attr,
 #endif
 #endif
+#ifdef CONFIG_ARCH_CELESTIAL
+    &irqs_to_mask_attr.attr,
+    &gpio_wakeup_attr.attr,
+#endif
 	NULL,
 };
 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/kernel/power/power.h linux-linaro-3.4-2012.05-1_cavium/kernel/power/power.h
--- linux-linaro-3.4-2012.05-1_original/kernel/power/power.h	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/kernel/power/power.h	2014-07-29 17:28:38.819972000 +0800
@@ -3,6 +3,10 @@
 #include <linux/utsname.h>
 #include <linux/freezer.h>
 
+#ifdef CONFIG_ARCH_CELESTIAL
+#define MAX_MASKABLE_IRQS (96)
+#endif
+
 struct swsusp_info {
 	struct new_utsname	uts;
 	u32			version_code;
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/kernel/power/suspend.c linux-linaro-3.4-2012.05-1_cavium/kernel/power/suspend.c
--- linux-linaro-3.4-2012.05-1_original/kernel/power/suspend.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/kernel/power/suspend.c	2014-07-29 17:28:38.819972000 +0800
@@ -20,14 +20,23 @@
 #include <linux/kernel.h>
 #include <linux/list.h>
 #include <linux/mm.h>
+#include <linux/mman.h>
 #include <linux/slab.h>
 #include <linux/export.h>
+#include <linux/interrupt.h>
 #include <linux/suspend.h>
 #include <linux/syscore_ops.h>
 #include <trace/events/power.h>
+#include <linux/err.h>
 
 #include "power.h"
 
+#ifdef CONFIG_ARCH_CELESTIAL
+extern uint32_t irq_list_length;
+extern uint32_t irq_mask_list[MAX_MASKABLE_IRQS];
+
+typedef int (*my_funcptr)(uint32_t, uint32_t *, uint32_t);
+#endif
 const char *const pm_states[PM_SUSPEND_MAX] = {
 	[PM_SUSPEND_STANDBY]	= "standby",
 	[PM_SUSPEND_MEM]	= "mem",
@@ -257,6 +266,78 @@
 	pm_restore_console();
 }
 
+#ifdef CONFIG_ARCH_CELESTIAL
+#define GPIO8_NO_IE                 (-1)
+#define DEV_MEM_OPEN_FAILURE        (-2)
+#define MMAP_FAILURE                (-3)
+#define LINE_BUFFER_FUNCTION_FAIL   (-4)
+
+static int cnc1900_go_to_sleep(void)
+{
+    extern uint32_t gpio_wakeup_list;
+    void *line_buffer_addr = NULL;
+    struct file *fp;
+    my_funcptr line_buffer_function = NULL;
+    int status = 42, rv = -1;
+    unsigned long mapped_address, ma__UL;
+    uint32_t contents = 0;
+    volatile uint32_t *gpio_va = NULL, *idscs_va = NULL;
+
+    gpio_va = ioremap_nocache(0x80260000, 0x10000);
+    idscs_va = ioremap_nocache(0xb2100000, 0x10000);
+    contents = gpio_va[10];
+
+    /* Normally, one does not wish to open a file in kernel space. However,
+       we need a file structure for the do_mmap() call, and the "file" in
+       this case is really system memory.  */
+    fp = filp_open("/dev/mem", O_RDWR, 0666);
+    if (IS_ERR(fp)) {
+        printk(KERN_ERR "%s: could not open /dev/mem\n", __func__);
+        return DEV_MEM_OPEN_FAILURE;
+    } else {
+        printk(KERN_DEBUG "%s: opened /dev/mem\n", __func__);
+    }
+
+    /* Assign line buffer address. We can't simply use ioremap and friends
+       because we need the pages to be executable. After all, we'ere going to
+       jump here and run code. */
+    down_write(&(current->mm->mmap_sem));
+    ma__UL = mapped_address = do_mmap(fp, 0, 0x10000, PROT_READ|PROT_EXEC, MAP_PRIVATE,
+                             0x80000000);
+    up_write(&(current->mm->mmap_sem));
+    filp_close(fp, NULL);
+
+    ma__UL += 4096ul;
+    if (ma__UL >= 1ul && ma__UL < 4096) {
+        printk(KERN_ERR "%s: mapping failure: do_mmap returned -%lu\n", __func__,
+               ma__UL);
+        return MMAP_FAILURE;
+    } else {
+        printk(KERN_DEBUG "%s: mapped address of line buffer: %08lx\n",
+               __func__, mapped_address);
+    }
+    contents = idscs_va[80];
+    printk(KERN_DEBUG "%s: clock enable register (b2100140) is %08x\n", __func__, contents);
+    mdelay(100);
+    /* 0x40 allows 16 words for a stack frame. */
+    line_buffer_addr = (void *)(mapped_address + 0x40);
+    line_buffer_function = (my_funcptr)line_buffer_addr;
+
+    /* Jump to the line buffer */
+    status = line_buffer_function(irq_list_length, &irq_mask_list[0], gpio_wakeup_list);
+    if (status != 0) {
+        printk(KERN_ERR "%s: line_buffer_function returned 0x%08x\n", __func__, status);
+        rv = LINE_BUFFER_FUNCTION_FAIL;
+    } else {
+        rv = 0;
+    }
+    printk(KERN_INFO "%s: finished waking up.\n", __func__);
+
+    /* Continue on as if nothing happened. */
+    return rv;
+}
+#endif
+
 /**
  * enter_state - Do common work needed to enter system sleep state.
  * @state: System sleep state to enter.
@@ -267,7 +348,7 @@
  */
 static int enter_state(suspend_state_t state)
 {
-	int error;
+	int error, res = -1;
 
 	if (!valid_state(state))
 		return -ENODEV;
@@ -275,29 +356,51 @@
 	if (!mutex_trylock(&pm_mutex))
 		return -EBUSY;
 
-	printk(KERN_INFO "PM: Syncing filesystems ... ");
-	sys_sync();
-	printk("done.\n");
-
-	pr_debug("PM: Preparing system for %s sleep\n", pm_states[state]);
-	error = suspend_prepare();
-	if (error)
-		goto Unlock;
-
-	if (suspend_test(TEST_FREEZER))
-		goto Finish;
+#ifdef CONFIG_ARCH_CELESTIAL
+	if (state == PM_SUSPEND_MEM) {
 
-	pr_debug("PM: Entering %s sleep\n", pm_states[state]);
-	pm_restrict_gfp_mask();
-	error = suspend_devices_and_enter(state);
-	pm_restore_gfp_mask();
+        // Disable interrupts, jump to line buffer, etc. Hack, hack...
+        printk(KERN_DEBUG "entering cnc1900_go_to_sleep() from enter_state(%d)\n", state);
+        res = cnc1900_go_to_sleep();
+
+		mutex_unlock(&pm_mutex);
+        if (res != 0) {
+            printk(KERN_ERR "Failed to execute STR: cnc1900_go_to_sleep() returned with an error\n");
+            return -ENODEV;
+        }
+        return 0;
+
+	} else {
+#endif
+
+        printk(KERN_INFO "PM: Syncing filesystems ... ");
+        sys_sync();
+        printk("done.\n");
+
+        pr_debug("PM: Preparing system for %s sleep\n", pm_states[state]);
+        error = suspend_prepare();
+        if (error)
+            goto Unlock;
+
+        if (suspend_test(TEST_FREEZER))
+            goto Finish;
+
+        pr_debug("PM: Entering %s sleep\n", pm_states[state]);
+        pm_restrict_gfp_mask();
+        error = suspend_devices_and_enter(state);
+        pm_restore_gfp_mask();
 
  Finish:
-	pr_debug("PM: Finishing wakeup.\n");
-	suspend_finish();
+        pr_debug("PM: Finishing wakeup.\n");
+        suspend_finish();
  Unlock:
-	mutex_unlock(&pm_mutex);
-	return error;
+        mutex_unlock(&pm_mutex);
+        return error;
+
+#ifdef CONFIG_ARCH_CELESTIAL
+    }
+#endif
+
 }
 
 /**
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/kernel/softirq.c linux-linaro-3.4-2012.05-1_cavium/kernel/softirq.c
--- linux-linaro-3.4-2012.05-1_original/kernel/softirq.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/kernel/softirq.c	2014-07-29 17:28:38.819972000 +0800
@@ -156,7 +156,9 @@
 
 static inline void _local_bh_enable_ip(unsigned long ip)
 {
+#ifndef CONFIG_PUREVU /* skip this warning if PUREVU, since this is in the standard send path */
 	WARN_ON_ONCE(in_irq() || irqs_disabled());
+#endif
 #ifdef CONFIG_TRACE_IRQFLAGS
 	local_irq_disable();
 #endif
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/kernel/trace/trace.c linux-linaro-3.4-2012.05-1_cavium/kernel/trace/trace.c
--- linux-linaro-3.4-2012.05-1_original/kernel/trace/trace.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/kernel/trace/trace.c	2014-07-29 17:28:38.819972000 +0800
@@ -3751,8 +3751,7 @@
 	struct page *pages[2];
 	int nr_pages = 1;
 	ssize_t written;
-	void *page1;
-	void *page2;
+	void *page1, *page2 = NULL;
 	int offset;
 	int size;
 	int len;
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/lib/idr.c linux-linaro-3.4-2012.05-1_cavium/lib/idr.c
